function [imaUdeb, imaMdeb, imaPdeb]=CompSoftThDWT2(imb, sb, J0, Wname)
%t1 = clock;
%%%%%%%%%%%%%%    GLOBAL THRESHOLDS
Long=numel(imb);
lambdaU=sqrt(2*log(Long));
lambdaM = 0.3936 + 0.1829*(log(Long)/log(2));
lambdaP=0.5*lambdaU+log(1+sqrt(1-1/(Long)^2))/lambdaU;
%%
%%%%%%%%%%%%%%    DECOMPOSITION
[Coeff,S]=wavedec2(imb,J0,Wname);
Lc=length(Coeff);
DetCoef=Coeff((1+S(1,1)*S(1,2)):Lc);
%%
%%%%%%%%%%%%%%%%  SOFT THRESHOLDING   
DetCoefU=sb.*SoftThresh(DetCoef./sb, lambdaU);
DetCoefM=sb.*SoftThresh(DetCoef./sb, lambdaM);
DetCoefP=sb.*SoftThresh(DetCoef./sb, lambdaP);
%%
%%%%%%%%%%%%%%%%  RECONSTRUCTION
CoeffU=[Coeff(1:S(1,1)*S(1,2)) DetCoefU];
CoeffM=[Coeff(1:S(1,1)*S(1,2)) DetCoefM];
CoeffP=[Coeff(1:S(1,1)*S(1,2)) DetCoefP];
imaUdeb=waverec2(CoeffU,S,Wname);
imaMdeb=waverec2(CoeffM,S,Wname);
imaPdeb=waverec2(CoeffP,S,Wname);
%%
% t2 = clock; elaps = t2 - t1; elaps(4)*3600+elaps(5)*60+elaps(6); %
% elapsed time, in seconds
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright: am.atto@telecom-bretagne.eu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%