function [imaUdeb, imaMdeb, imaPdeb, imaAdeb]=CompSoftThSWT2(imb, sb, J0, Wname)
%%%%%%%%%%%%%%    DECOMPOSITION
%t1 = clock;
[SCA,SCH,SCV,SCD]=swt2(imb,J0,Wname);
SWH=SCH;
SWV=SCV;
SWD=SCD;
SXH=SCH;
SXV=SCV;
SXD=SCD;
SYH=SCH;
SYV=SCV;
SYD=SCD;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Long=numel(imb);
lambdaU=sqrt(2*log(Long));
lambdaM = 0.3936 + 0.1829*(log(Long)/log(2));
lambdaP=0.5*lambdaU+log(1+sqrt(1-1/(Long)^2))/lambdaU;
lambdaA=lambdaP./sqrt(2).^(0:J0-1);
 %%%%%%%  SEUILLAGE SOFT   %%%%%%%%%%
SCH=sb.*SoftThresh(SCH./sb, lambdaU);
SCV=sb.*SoftThresh(SCV./sb, lambdaU);
SCD=sb.*SoftThresh(SCD./sb, lambdaU);
SWH=sb.*SoftThresh(SWH./sb, lambdaM);
SWV=sb.*SoftThresh(SWV./sb, lambdaM);
SWD=sb.*SoftThresh(SWD./sb, lambdaM);
SXH=sb.*SoftThresh(SXH./sb, lambdaP);
SXV=sb.*SoftThresh(SXV./sb, lambdaP);
SXD=sb.*SoftThresh(SXD./sb, lambdaP);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:J0
    SYH(:,:,j)=sb.*SoftThresh(SYH(:,:,j)./sb, lambdaA(j));
    SYV(:,:,j)=sb.*SoftThresh(SYV(:,:,j)./sb, lambdaA(j));
    SYD(:,:,j)=sb.*SoftThresh(SYD(:,:,j)./sb, lambdaA(j));
end
%%%%%%%%%%%%%%%%  RECONSTRUCTION
imaUdeb=iswt2(SCA,SCH,SCV,SCD,Wname);
imaMdeb=iswt2(SCA,SWH,SWV,SWD,Wname);
imaPdeb=iswt2(SCA,SXH,SXV,SXD,Wname);
imaAdeb=iswt2(SCA,SYH,SYV,SYD,Wname);
% t2 = clock; elaps = t2 - t1; elaps(4)*3600+elaps(5)*60+elaps(6); % elapsed time, in seconds
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright: am.atto@telecom-bretagne.eu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%