%%%%%%%%%%%%%%%%%%  REQUIRES WaveLab Toolbox   %%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Images pertaining to Class \Theta according to the SNR (see readme) %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all
clear all
%%%%%%%%%%%%%   image
% Load original images
ImgName={'testimages/house.png' 'testimages/peppers256.png' 'testimages/barbara.png' 'testimages/lena.png' 'testimages/fingerprint.png' 'testimages/boat.png'}; 
Lsn=length(ImgName);
zetaN=zeros(1,Lsn);  % \zeta(N)
j0=4;   % N=2^(j+1) % Decomposition level
qmf=MakeONFilter('Symmlet',8);
CLASS_THETA=zeros(Lsn, 4);
sigma=5:10:35;
%%%%%%%%%%%%%%%%%
for m=1:Lsn
    IName=char(ImgName(m));
    im0 = imread(IName);
    mini=min(min(im0));
    if mini<0
        im0=im0+abs(mini);
    end
    im0 = double(im0);  % convert it to double
    [Ny,Nx] = size(im0);
    Nxy=min(Nx,Ny);
    J=log2(Nxy)-j0;  % resolution level in wavelab sense
    N=Nx*Ny;
    zetaN(m)=N^(-1/4)*(1+sqrt(1-1/N^2))^(-1/2)*exp(-(log(1+sqrt(1-1/N^2)))^2 / (4*log(N))); 
    wc = FTWT2_PO(im0,J,qmf);
    rwc=reshape(wc,1,N);
    for k=1:4
        CLASS_THETA(m,k)=((sigma(k))^2*length(find(abs(rwc)>=(sigma(k))))+sum(rwc(find(abs(rwc)<(sigma(k)))).^2))/N;   % r0(\theta)
    end
end
figure
plot(CLASS_THETA(:,1),'ro:')
hold on
plot((sigma(1))^2.*zetaN,'b+:')
hold off
xlabel('Image index')
legend('r_0(\theta)','\zeta(N)')
title('\sigma=5')

figure
plot(CLASS_THETA(:,2),'ro:')
hold on
plot((sigma(2))^2.*zetaN,'b+:')
hold off
xlabel('Image index')
legend('r_0(\theta)','\zeta(N)')
title('\sigma=15')

figure
plot(CLASS_THETA(:,3),'ro:')
hold on
plot((sigma(3))^2.*zetaN,'b+:')
hold off
xlabel('Image index')
legend('r_0(\theta)','\zeta(N)')
title('\sigma=25')

figure
plot(CLASS_THETA(:,4),'ro:')
hold on
plot((sigma(4))^2.*zetaN,'b+:')
hold off
xlabel('Image index')
legend('r_0(\theta)','\zeta(N)')
title('\sigma=35')
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright: am.atto@telecom-bretagne.eu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%