%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Requires WaveLab toolbox                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         Signals and their DWPT representattions        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all
clear all

SigName={'Blocks' 'Doppler' 'Cusp' 'HypChirps'}; 
Lsn=length(SigName);
N = 2^11;
WName='sym8';
j0=6;   % Decomposition level 1<=j0<=10
qmf=MakeONFilter('Symmlet',8);
rho=7;
J=log2(N)-j0;  % Resolution level (in wavelab sense)
%%%%%%%%%%%%%%%%%%%%
for m=1:Lsn
    SName=char(SigName(m));
    Sig=MakeSignal(SName,N);
    rand('seed',0);
    [xSig,ySig] = NoiseMaker(Sig,rho);
    figure
    plot(xSig)
    title(SName)
    wc = FWT_PO(xSig,J,qmf);
    figure
    plot(wc)
    title(['DWT ' SName])
end
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright: am.atto@telecom-bretagne.eu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%