%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Requires WaveLab toolbox                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%  Images and their DWT representations 
%%%%%%%%%%%             - versus - 
%%%%%%%%%%%  DWT representations of noisy signals
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all
clear all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load original images
ImgName={'testimages/house.png' 'testimages/peppers256.png' 'testimages/barbara.png' 'testimages/lena.png' 'testimages/fingerprint.png' 'testimages/boat.png'}; 
Lsn=length(ImgName);
j0=4;   % N=2^(j+1) % Decomposition level
qmf=MakeONFilter('Symmlet',8);
m=6; %m is the image number to test: m=1 corresponds to 'house.png'
IName=char(ImgName(m));
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
im0 = imread(IName);
mini=min(min(im0));
if mini<0
    im0=im0+abs(mini);
end
im0 = double(im0);  % convert it to double
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[Ny,Nx] = size(im0);
Nxy=min(Nx,Ny);
J=log2(Nxy)-j0;  % resolution level in wavelab sense
N=Nx*Ny;
wc = FTWT2_PO(im0,J,qmf);
rwc=reshape(wc,1,N);
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sbn=35;
seed = 0;               % random seed
randn('state', seed);
noise = randn(size(im0));
noise = noise/sqrt(mean2(noise.^2));
imb = im0 + sbn*noise;
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
wcn = FTWT2_PO(imb,J,qmf);
rwcn=reshape(wcn,1,N);
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
colormap(gray)
imagesc(im0)
title('Original Image')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
plot(rwc)
title('DWT Original Image')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
colormap(gray)
imagesc(imb)
title('Noisy Image')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
plot(rwcn)
title('DWT Noisy Image')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright: am.atto@telecom-bretagne.eu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%